/* _______              __
  / ___/ /  ___  __ _  / /  ___
 / /__/ _ \/ _ \/  ' \/ _ \/ _ \
 \___/_//_/\___/_/_/_/_.__/\___/ 
*/

// VelocityPoissonOp.H

//
// This software is copyright (C) by the Lawrence Berkeley
// National Laboratory.  Permission is granted to reproduce
// this software for non-commercial purposes provided that
// this notice is left intact.
// 
// It is acknowledged that the U.S. Government has rights to
// this software under Contract DE-AC03-765F00098 between
// the U.S.  Department of Energy and the University of
// California.
//
// This software is provided as a professional and academic
// contribution for joint exchange. Thus it is experimental,
// is provided ``as is'', with no warranties of any kind
// whatsoever, no support, no promise of updates, or printed
// documentation. By using this software, you acknowledge
// that the Lawrence Berkeley National Laboratory and
// Regents of the University of California shall have no
// liability with respect to the infringement of other
// copyrights by any part of this software.
//
// Dan Martin, Fri, Jan 14, 2000

#ifndef _VelocityPoissonOp_H_
#define _VelocityPoissonOp_H_

#include "PoissonOp.H"
#include "Vector.H"


class VelocityPoissonOp: public PoissonOp
{
  
public:

  ///
  /** 
      virtual constructor workaround
  */
  LevelOp* new_levelop() const;
  
  /// 
  VelocityPoissonOp();
  
  ///
  ~VelocityPoissonOp();

  ///
  /** The raison d'etre for this class -- want to be able to 
      apply operator with different BCs for each component
      in a_phi. */
  void applyOpI(LevelData<FArrayBox>& a_phi,
		const LevelData<FArrayBox>* a_phiCoarse,
		LevelData<FArrayBox>& a_LOfPhi,
		Vector<DomainGhostBC>& a_bcVect);


  ///
  virtual bool isDefined() const;

protected:
  

private:

};
		


#endif


